#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

struct Vertex {
    int num, pose;
    std::vector<int> u;
};

std::vector<int> pos_now, pos_wanted;
std::vector<int> a;
std::vector<int> b, b_s;
std::map<int, int> define;
std::vector<std::set<int>> g;
std::vector<bool> visited;
std::vector<int> way;
int n;
bool find;

void try_way(int want, int v) {
    visited[v] = true;
    if (pos_now[v] == want) {
        find = true;
        return;
    }
    for (auto u : g[v]) {
        if (!visited[u]) {
            way.push_back(u);
            try_way(want, u);
            if (find)
                return;
            way.pop_back();
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    //std::iostream::sync_with_stdio(false);
    //std::cin.tie(0), std::cout.tie(0);
    std::cin >> n;
    g.resize(n);
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        b[i] = a[i];
    }
    std::sort(b.begin(), b.end());
    for (int i = 0; i < n; i++) {
        define[a[i]] = i;
    }
    pos_now.resize(n), pos_wanted.resize(n);
    for (int  i = 0; i < n; i++) {
        pos_now[i] = i;
        pos_wanted[define[b[i]]] = i;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j && (a[i] % a[j] == 0 || a[j] % a[i] == 0)) {
                g[i].insert(j);
                g[j].insert(i);
            }
        }
    }
    std::vector<std::pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        if (pos_now[i] != pos_wanted[i]) {
            visited.assign(n, false);
            way = {i};
            find = false;
            try_way(pos_wanted[i], i);
            if (find) {
                for (int j = 1; j < way.size(); j ++) {
                    ans.push_back({a[way[j]], a[way[j - 1]]});
                    std::swap(pos_now[way[j]], pos_now[way[j - 1]]);
                }
                for (int j = way.size() - 2; j > 0; j--) {
                    ans.push_back({a[way[j]], a[way[j - 1]]});
                    std::swap(pos_now[way[j]], pos_now[way[j - 1]]);
                }
            } else {
                std::cout << -1;
                return 0;
            }
        }
    }
    std::cout << ans.size() << '\n';
    for (auto [f, s] : ans)
        std::cout << f << ' ' << s << '\n';
    return 0;
}
